﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.32
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private xui As XUI
	Private mBase As B4XView
	Private canvas As B4XView
	'Private mask As B4XCanvas
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(base As B4XView) 
	mBase = base
	mBase.LoadLayout("1")
	canvas.AddView(CreateMask(canvas.Height,canvas.Width,True,True,False,False, xui.Color_Black,20dip),0,0,canvas.Width,canvas.Height)
End Sub


'returns an imageview with a bmp mask of the selected corners
'size of the canvas, the selected corners, backgound color and the radius
'doesn't work and when i resize the mask, in androy may work great as the activity is recreated, not in b4i and b4j
Private Sub CreateMask(Height As Int, Width As Int, top_left As Boolean, _
						top_rigth As Boolean, bottom_left As Boolean, bottom_right As Boolean, BackgroundColor As Int, radius As Int) As B4XView
	Dim mask As B4XCanvas
	mask.Initialize(xui.CreatePanel(""))
	mask.Resize(Width,Height)
	
	'paint
	Dim p_left_top, p_left_bottom, p_right_top, p_right_bottom, p_medium_square, p_larger_square As B4XPath
	Dim r, medium_square, larger_square As B4XRect
	r.Initialize(0, 0, Width, Height)

	'background
	mask.DrawRect(r,BackgroundColor,True,1dip)
	
	'left-top corner
	If top_left Then
		p_left_top.InitializeArc(radius,radius,radius,180,90)
		mask.ClipPath(p_left_top) '<-- i Try To crop instead paint, but doesnt work.
		'mask.DrawPath(p_left_top,xui.Color_Green,True,1dip)
	Else
		p_left_top.InitializeArc(radius,radius,radius*2,180,90) ' <- i does this instead pain an scuare with rect
		mask.ClipPath(p_left_top) '<-- i Try To crop instead paint, but doesnt work.
		'mask.DrawPath(p_left_top,xui.Color_Green,True,1dip)
	End If
	
	'left-bottom
	If bottom_left Then
		p_left_bottom.InitializeArc(radius,Height-radius,radius,90,90)
		mask.ClipPath(p_left_bottom) '<-- i try to crop instead paint, but doesnt work.
		'mask.DrawPath(p_left_bottom,xui.Color_Green,True,1dip)
	Else
		p_left_bottom.InitializeArc(radius,Height-radius,radius*2,90,90)
		mask.ClipPath(p_left_bottom)' <-- i try to crop instead paint, but doesnt work.
		'mask.DrawPath(p_left_bottom,xui.Color_Green,True,1dip)
	End If
	
	'right-top corner
	If top_rigth Then
		p_right_top.InitializeArc(Width-radius,radius,radius,270,90)
		mask.ClipPath(p_right_top) '<-- i try to crop instead paint, but doesnt work.
		'mask.DrawPath(p_right_top,xui.Color_Green,True,1dip)
	Else
		p_right_top.InitializeArc(Width-radius,radius,radius*2,270,90)
		mask.ClipPath(p_right_top) '<-- i try to crop instead paint, but doesnt work.
		'mask.DrawPath(p_right_top,xui.Color_Green,True,1dip)
	End If
	
	'right-bottom corner
	If bottom_right Then
		p_right_bottom.InitializeArc(Width-radius,Height-radius,radius,0,90)
		mask.ClipPath(p_right_bottom) '<-- i try to crop instead paint, but doesnt work.
		'mask.DrawPath(p_right_bottom,xui.Color_Green,True,1dip)
	Else
		p_right_bottom.InitializeArc(Width-radius,Height-radius,radius*2,0,90)
		mask.ClipPath(p_right_bottom) '<-- i try to crop instead paint, but doesnt work.
		'mask.DrawPath(p_right_bottom,xui.Color_Green,True,1dip)
	End If
	
	
	'medium square
	medium_square.Initialize(0,radius,Width,Height-radius)
	p_medium_square.Initialize(0,radius)
	p_medium_square.InitializeRoundedRect(medium_square,0)
	mask.ClipPath(p_medium_square) '<-- i try to crop instead paint, but doesnt work.
	'mask.DrawPath(p_medium_square,xui.Color_Green,True,1dip)
	
	'larger square
	larger_square.Initialize(radius,0,Width-radius,Height)
	p_larger_square.Initialize(radius,0)
	p_larger_square.InitializeRoundedRect(larger_square,0)
	mask.ClipPath(p_larger_square) '<-- i try to crop instead paint, but doesnt work.
	'mask.DrawPath(p_larger_square,xui.Color_Green,True,1dip)
	
	'commit painting, get the bitmap and create the imageview
	mask.Invalidate
	Dim bmp As B4XBitmap = mask.CreateBitmap
	Dim pane As B4XView = CreateImagePanel(Height,Width)
	pane.SetBitmap(bmp)
	Return pane
End Sub

'create a panel from the primitives width sizes
Private Sub CreateImagePanel(Height As Int, Width As Int) As B4XView
	#If b4a
		'nada
	#Else if b4j
		Dim pane As ImageView
		pane.Initialize("")
		pane.SetSize(Width,Height)
		Return pane
	#End If
End Sub